#ifndef __ERR_NUM_H__
#define __ERR_NUM_H__

#define OSP_OK              (0)     /* 正常返回 */
#define OSP_PAR_ILL         (1)     /* 入参错误 */
#define OSP_PAR_REP         (2)     /* 入参重复 */
#define OSP_QUE_FULL        (3)     /* 软队列满 */
#define OSP_QUE_EMPT        (4)     /* 软队列空 */
#define OSP_MEM_FULL        (5)     /* 内存申请失败 */
#define OSP_NO_FILE         (6)     /* 无对应配置文件 */
#define OSP_ERROR           (7)     /* 失败返回 */
#define OSP_HW_BAND         (8)     /* 硬件队列绑定失败 */
#define OSP_HW_VECT         (9)     /* 硬件队列获取中断号失败 */
#define OSP_HW_IRQ          (10)    /* 硬件队列注册中断服务失败 */
#define OSP_HW_EMPTY_ERR    (11)    /* 硬件队列非空中断使能失败 */
#define OSP_TASK_INIT_ERR   (12)    /* 任务初始化函数返回失败 */

#endif

