// +FHDR------------------------------------------------------------
//                 Copyright (c) 2022 SmartLogic.
//                       ALL RIGHTS RESERVED
// -----------------------------------------------------------------
// Filename      : ape_top.h
// Author        : xianfeng.du
// Created On    : 2022-06-25
// Last Modified :
// -----------------------------------------------------------------
// Description:
//
//
// -FHDR------------------------------------------------------------

#ifndef __APE_SPU_TOP_H__
#define __APE_SPU_TOP_H__

#include "typedef.h"
#include "ucp_utility.h"

ALWAYS_INLINE int32_t get_core_id(void);
void set_core_id(void);
int32_t soc_drv_init(void);
void spu_drv_init(void);
void spu_msg_transfer_init(void);

#endif


