#ifndef _JESD_DRV_PARA_
#define _JESD_DRV_PARA_

#include "typedef.h"

typedef struct JesdDelay
{
	// 10ms offset, ns as unit
	uint32_t	tx_offset;
	uint32_t	rx_offset;
	uint32_t	tdd_offset;

	uint32_t    gps_offset;
	// 10ms tx/rx offset to pp1s
	int32_t 	jesd_10ms2pp1s_txoffset;
	int32_t 	jesd_10ms2pp1s_rxoffset;
	int32_t 	jesd_tdd2pp1s_offset;
}JesdDelay_t;

typedef struct JesdOrxPara
{
	uint32_t orx_calldrv_cnt;
	uint32_t orx_start_flag;
	uint32_t orx_start_offset_us;
	uint32_t orx_adjust_flag;
	uint32_t orx_adjust_val_lo;
	uint32_t orx_adjust_val_hi;
	uint32_t pp1s_adjust_flag;
}JesdOrxPara_t;



#endif

