// +FHDR------------------------------------------------------------
//                 Copyright (c) 2022 SmartLogic.
//                       ALL RIGHTS RESERVED
// -----------------------------------------------------------------
// Filename      : ucp_mem_dump.h
// Author        : xianfeng.du
// Created On    : 2022-08-29
// Last Modified :
// -----------------------------------------------------------------
// Description:
//
//
// -FHDR------------------------------------------------------------

#ifndef __UCP_MEM_DUMP_H__
#define __UCP_MEM_DUMP_H__

#include "typedef.h"

void vec_dump(char* filename, uint32_t address, uint32_t length);
void vec_read(char* filename, uint32_t address);


//#define DDR_DUMP_ENABLE

#ifdef DDR_DUMP_ENABLE
#define ddr_dump(a,b,c) vec_dump((char *)a,(uint32_t)b,(uint32_t)c)
#define ddr_read(a,b) vec_read((char *)a,(uint32_t)b)
#else
#define ddr_dump(a,b,c)
#define ddr_read(a,b)
#endif


#endif

